#include <SPI.h>
#include <MFRC522.h>
#include <Servo.h>
#include <LiquidCrystal.h>

#define SS_PIN 10
#define RST_PIN 9
#define LED_G 5
#define LED_R 4
#define BUZZER 2
MFRC522 mfrc522(SS_PIN,RST_PIN);
Servo myservo;
LiquidCrystal lcd(A0,A1,A2,A3,A4,A5);

void setup()
{ 
 Serial.begin(9600);
  SPI.begin();
  pinMode(6,OUTPUT);
  lcd.begin(16,2);
  mfrc522.PCD_Init();
  myservo.attach(3);
  
  myservo.write(0);
 
  pinMode(LED_G,OUTPUT);
  pinMode(LED_R,OUTPUT);
  pinMode(BUZZER,OUTPUT);
  noTone(BUZZER);
  Serial.println("Put your card to the reader...");
  Serial.println();
  
  lcd.print(" Scanati cartela");
  
}
void loop(){
  analogWrite(6,100);
 lcd.setCursor(0,0);
  lcd.print(" Buna Ziua");
  lcd.setCursor(0,1);
  lcd.print(" Scanati cartela");
  if( !mfrc522.PICC_IsNewCardPresent()){
    return;    
  }
  if( !mfrc522.PICC_ReadCardSerial()){
    return;    
  }
  Serial.print("UID tag:");
  String content="";
  byte letter;
  for(byte i = 0; i < mfrc522.uid.size;i++){
     Serial.print(mfrc522.uid.uidByte[i] < 0x10 ? "0" : " ");
     Serial.print(mfrc522.uid.uidByte[i],HEX);
    content.concat(String(mfrc522.uid.uidByte[i] < 0x10 ? "0" : " "));
    content.concat(String(mfrc522.uid.uidByte[i],HEX)); 
    
  }
  Serial.println();
  Serial.println("Message : ");
  content.toUpperCase();
  if(content.substring(1) == "75 42 AD 26"){
    Serial.println("Access granted");
    Serial.println();
    delay(500);
    digitalWrite(LED_G,HIGH);
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print(" ***Verified***");
    lcd.setCursor(0,1);
      lcd.print("Spor la lucru");
      tone(BUZZER,500);
      delay(300);
      noTone(BUZZER);
      myservo.write(180);
      delay(500);
      myservo.write(0);
      digitalWrite(LED_G,LOW);
      lcd.clear();
     
  }
  else{
    Serial.println("Access denied");
         digitalWrite(LED_R,HIGH);
         lcd.clear();
          lcd.setCursor(0,0);
      //    lcd.print(" Invalid key");
          tone(BUZZER,300);
          delay(1000);
          digitalWrite(LED_R,LOW);
          lcd.clear();
          noTone(BUZZER);
        
    
  }
  
  
}
